
<!DOCTYPE html>
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
		<title>service: Go Coverage Report</title>
		<style>
			body {
				background: black;
				color: rgb(80, 80, 80);
			}
			body, pre, #legend span {
				font-family: Menlo, monospace;
				font-weight: bold;
			}
			#topbar {
				background: black;
				position: fixed;
				top: 0; left: 0; right: 0;
				height: 42px;
				border-bottom: 1px solid rgb(80, 80, 80);
			}
			#content {
				margin-top: 50px;
			}
			#nav, #legend {
				float: left;
				margin-left: 10px;
			}
			#legend {
				margin-top: 12px;
			}
			#nav {
				margin-top: 10px;
			}
			#legend span {
				margin: 0 5px;
			}
			.cov0 { color: rgb(192, 0, 0) }
.cov1 { color: rgb(128, 128, 128) }
.cov2 { color: rgb(116, 140, 131) }
.cov3 { color: rgb(104, 152, 134) }
.cov4 { color: rgb(92, 164, 137) }
.cov5 { color: rgb(80, 176, 140) }
.cov6 { color: rgb(68, 188, 143) }
.cov7 { color: rgb(56, 200, 146) }
.cov8 { color: rgb(44, 212, 149) }
.cov9 { color: rgb(32, 224, 152) }
.cov10 { color: rgb(20, 236, 155) }

		</style>
	</head>
	<body>
		<div id="topbar">
			<div id="nav">
				<select id="files">
				
				<option value="file0">gitlab.com/danialmaki.dm/2_go_layout/internal/service/getnounce.go (85.7%)</option>
				
				<option value="file1">gitlab.com/danialmaki.dm/2_go_layout/pkg/hash/simplehash.go (100.0%)</option>
				
				</select>
			</div>
			<div id="legend">
				<span>not tracked</span>
			
				<span class="cov0">not covered</span>
				<span class="cov8">covered</span>
			
			</div>
		</div>
		<div id="content">
		
		<pre class="file" id="file0" style="display: none">package service

import (
        "context"
        "fmt"

        pb "gitlab.com/danialmaki.dm/2_go_layout/pkg/autogenerated"
        "gitlab.com/danialmaki.dm/2_go_layout/pkg/hash"
)

type server struct {
        pb.UnimplementedSubmitServiceServer
        hasher     hash.Hash
        lastNChars string
}

func (s *server) GetNonce(ctx context.Context, req *pb.SubmitRequest,
) (res *pb.SubmitResponse, e error) <span class="cov8" title="1">{
        var nonce int64
        for </span><span class="cov8" title="1">{
                record, err := s.hasher.GetRecord(req, nonce)
                if err != nil </span><span class="cov0" title="0">{
                        return nil, err
                }</span>
                <span class="cov8" title="1">hashedRecord, err := s.hasher.GetSha256(record)
                if err != nil </span><span class="cov0" title="0">{
                        return nil, err
                }</span>
                <span class="cov8" title="1">if hashedRecord[len(hashedRecord)-len(s.lastNChars):] == s.lastNChars </span><span class="cov8" title="1">{
                        fmt.Println(hashedRecord)
                        break</span>
                }
                <span class="cov8" title="1">nonce += 1</span>
        }
        <span class="cov8" title="1">return &amp;pb.SubmitResponse{Nonce: nonce}, nil</span>
}

func New(lastNChars string) pb.SubmitServiceServer <span class="cov8" title="1">{
        return &amp;server{
                hasher:     hash.NewSimpleHash(),
                lastNChars: lastNChars,
        }
}</span>
</pre>
		
		<pre class="file" id="file1" style="display: none">package hash

import (
        "crypto/sha256"
        "encoding/hex"
        "fmt"

        pb "gitlab.com/danialmaki.dm/2_go_layout/pkg/autogenerated"
)

type simpleHash struct {
}

func (s *simpleHash) GetRecord(reqStruct *pb.SubmitRequest, nonce int64) (string, error) <span class="cov8" title="1">{
        return reqStruct.Src + reqStruct.Dest + fmt.Sprint(reqStruct.Amount) +
                fmt.Sprint(reqStruct.DateTime) + reqStruct.PrevHash + fmt.Sprint(nonce), nil
}</span>

func (s *simpleHash) GetSha256(str string) (string, error) <span class="cov8" title="1">{
        hashedByte := sha256.Sum256([]byte(str))
        return hex.EncodeToString(hashedByte[:]), nil
}</span>

func NewSimpleHash() Hash <span class="cov8" title="1">{
        return &amp;simpleHash{}
}</span>
</pre>
		
		</div>
	</body>
	<script>
	(function() {
		var files = document.getElementById('files');
		var visible;
		files.addEventListener('change', onChange, false);
		function select(part) {
			if (visible)
				visible.style.display = 'none';
			visible = document.getElementById(part);
			if (!visible)
				return;
			files.value = part;
			visible.style.display = 'block';
			location.hash = part;
		}
		function onChange() {
			select(files.value);
			window.scrollTo(0, 0);
		}
		if (location.hash != "") {
			select(location.hash.substr(1));
		}
		if (!visible) {
			select("file0");
		}
	})();
	</script>
</html>
